﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=BLEExample.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private btnReadData As B4XView
	Private btnDisconnect As B4XView
	Private btnScan As B4XView
	Private lblDeviceStatus As B4XView
	Private lblState As B4XView
	Private pbReadData As B4XLoadingIndicator
	Private clv As CustomListView
	#if B4A
	Private manager As BleManager3
	Private rp As RuntimePermissions
	#else if B4i
	Private manager As BleManager
	#end if
	Private currentStateText As String = "UNKNOWN"
	Private currentState As Int
	Private connected As Boolean = False
	Private ConnectedName As String
	Private ConnectedServices As List
	Private pbScan As B4XLoadingIndicator
	Dim phase As Int = 0 
	
	
	
	Private SERVICE_UUID As String         =        "B04EFAC2-E040-4AC1-A464-393508E6C2C9"
	Private ACCESS_CODE_UUID    As String      =         "E37ADC7D-4E0F-466E-8674-02FD0F8983BB"
	Private ACCESS_CODE_RESULT_UUID   As String    =     "1B476C5F-894E-4EEE-9EDC-B1DBF03A7744"
	Private btnRefreshServices As B4XView
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("1")
	B4XPages.SetTitle(Me, "BLE Example")
	manager.Initialize("manager")
	StateChanged
End Sub

Public Sub StateChanged
	lblState.Text = currentStateText
	If connected Then
		lblDeviceStatus.Text = "Connected: " & ConnectedName
	Else
		lblDeviceStatus.Text = "Not connected"
	End If
	btnDisconnect.Enabled = connected
	btnScan.Enabled = Not(connected)
	pbReadData.Hide
	pbScan.Hide
	btnReadData.Enabled = connected
	btnRefreshServices.Enabled = connected
	btnScan.Enabled = (currentState = manager.STATE_POWERED_ON) And connected = False
End Sub

Sub btnScan_Click
	#if B4A
	'Don't forget to add permission to manifest
	Dim Permissions As List
	Dim phone As Phone
	If phone.SdkVersion >= 31 Then
		Permissions = Array("android.permission.BLUETOOTH_SCAN", "android.permission.BLUETOOTH_CONNECT", rp.PERMISSION_ACCESS_FINE_LOCATION)
	Else
		Permissions = Array(rp.PERMISSION_ACCESS_FINE_LOCATION)
	End If
	For Each per As String In Permissions
		rp.CheckAndRequest(per)
		Wait For B4XPage_PermissionResult (Permission As String, Result As Boolean)
		If Result = False Then
			ToastMessageShow("No permission: " & Permission, True)
			Return
		End If
	Next
	#end if
	pbScan.Show
	StartScan
End Sub

Sub btnDisconnect_Click
	manager.Disconnect
	Manager_Disconnected
End Sub

Sub btnReadData_Click
	pbReadData.Show
	clv.Clear
	For Each s As String In ConnectedServices
		manager.ReadData(s)
	Next
End Sub

Sub CreateServiceItem (service As String) As Panel
	Dim pnl As B4XView = xui.CreatePanel("")
	pnl.Color = 0xFF808080
	pnl.SetLayoutAnimated(0, 0, 0, clv.AsView.Width, 30dip)
	Dim lbl As B4XView = XUIViewsUtils.CreateLabel
	lbl.Text = service
	lbl.SetTextAlignment("CENTER", "CENTER")
	lbl.Font = xui.CreateDefaultBoldFont(14)
	pnl.AddView(lbl, 0, 0, clv.AsView.Width, 30dip)
	Return pnl
End Sub

Sub CreateCharacteristicItem(Id As String, Data() As Byte) As Panel
	Dim pnl As B4XView = xui.CreatePanel("")
	pnl.SetLayoutAnimated(0, 0, 0, clv.AsView.Width, 40dip)
	pnl.Color = Colors.White
	Dim lbl As B4XView = XUIViewsUtils.CreateLabel
	lbl.Text = Id
	pnl.AddView(lbl, 0, 0, clv.AsView.Width, 20dip)
	Dim lbl2 As B4XView = XUIViewsUtils.CreateLabel
	Try
		lbl2.Text = BytesToString(Data, 0, Data.Length, "UTF8")
	Catch
		Log(LastException)
		lbl2.Text = "Error reading data as string"
	End Try
	lbl2.TextColor = 0xFF909090
	lbl2.TextSize = 14
	pnl.AddView(lbl2, 0, 20dip, clv.AsView.Width, 20dip)
	Return pnl
End Sub

Sub Manager_StateChanged (State As Int)
	Select State
		Case manager.STATE_POWERED_OFF
			currentStateText = "POWERED OFF"
		Case manager.STATE_POWERED_ON
			currentStateText = "POWERED ON"
		Case manager.STATE_UNSUPPORTED
			currentStateText = "UNSUPPORTED"
	End Select
	currentState = State
	StateChanged
End Sub

Sub Manager_DeviceFound (Name As String, Id As String, AdvertisingData As Map, RSSI As Double)
	Log("Found: " & Name & ", " & Id & ", RSSI = " & RSSI & ", " & AdvertisingData) 'ignore
	If Id = "C0:49:EF:D2:29:1A" Then
		ConnectedName = Name
		manager.StopScan
		
		Log("connecting")
		#if B4A
			manager.Connect3(Id, False, 2) 'disabling auto connect can make the connection quicker
		#else if B4I
			manager.Connect(Id)
		#end if
	End If
End Sub

Public Sub StartScan
	If manager.State <> manager.STATE_POWERED_ON Then
		Log("Not powered on.")
	Else
		manager.Scan2(Null, False)
	End If
End Sub

Sub Manager_DataAvailable (ServiceId As String, Characteristics As Map)
	pbReadData.Hide
	clv.Add(CreateServiceItem(ServiceId), "")
	For Each id As String In Characteristics.Keys
		clv.Add(CreateCharacteristicItem(id, Characteristics.Get(id)), "")
	Next
	
	If ServiceId == SERVICE_UUID.ToLowerCase Then
		For Each id As String In Characteristics.Keys
			Dim Data() As Byte = Characteristics.Get(id)
			'id = id.ToUpperCase
			
			Select id
				Case ACCESS_CODE_UUID.ToLowerCase
					Try
						LogColor($"Ricevuto: ${BytesToString(Data, 0, Data.Length, "UTF8")}"$, Colors.Magenta)
						phase = phase +1 
					Catch
						Log(LastException)
					End Try
					
				Case ACCESS_CODE_RESULT_UUID.ToLowerCase
					Try
						Dim response As Int = BytesToString(Data, 0, Data.Length, "UTF8")
						LogColor($"Ricevuto: ${response}"$, Colors.Magenta)
						manager.SetNotify(SERVICE_UUID.ToLowerCase, ACCESS_CODE_RESULT_UUID.ToLowerCase, True)
						phase = phase +1

					Catch
						Log(LastException)
					End Try
			End Select
		Next
	End If
	
	If phase >= 2 Then
		Sleep(100)
		phase = 0
		manager.WriteData(SERVICE_UUID.ToLowerCase, ACCESS_CODE_UUID.ToLowerCase, "123456".GetBytes("UTF8"))
	End If
End Sub

Sub Manager_Disconnected
	Log("Disconnected")
	connected = False
	StateChanged
End Sub

Sub Manager_Connected (services As List)
	Log("Connected")
	connected = True
	ConnectedServices = services
	StateChanged
	btnReadData_Click
End Sub

'utility to convert short UUIDs to long format on Android
Private Sub UUID(id As String) As String 'ignore
#if B4A
	Return "0000" & id.ToLowerCase & "-0000-1000-8000-00805f9b34fb"
#else if B4I
	Return id.ToUpperCase
#End If
End Sub

Sub Refresh_Services
	Dim gatt As JavaObject = manager.As(JavaObject).GetField("gatt")
	Dim services As List = gatt.RunMethod("getServices", Null)
	For Each service As JavaObject In services
		Log(service.RunMethod("getUuid", Null))
	Next
End Sub

Private Sub btnRefreshServices_Click
	Refresh_Services
End Sub